/* for the analysis we need sn id of certificate and the "acmecodes" string */

data step1;
infile "&path./acmecodes.csv" dsd missover;
length acmecodes $255.;
input acmecodes;
certificate=_n_;
run; 

/* here we work for preparing dataset for analysis of part1 of certificates 
PART2 Is missing, this may change*/
data step1; set step1;
length part1 a b c d $255. ;
length a1-a6 b1-b6 c1-c6 d1-d6 e1-e6 f1-f6 $5.;
part1=scan (acmecodes, 1, "*");

a=scan(part1, 1, "/");
b=scan(part1, 2, "/");
c=scan(part1, 3, "/");
d=scan(part1, 4, "/");
e=scan(part1, 5, "/");
f=scan(part1, 6, "/");
array vara (6) a1-a6; do i=1 to 6; vara(i)=scan(a, (i), " "); end;
array varb (6) b1-b6; do i=1 to 6; varb(i)=scan(b, (i), " "); end;
array varc (6) c1-c6; do i=1 to 6; varc(i)=scan(c, (i), " "); end;
array vard (6) d1-d6; do i=1 to 6; vard(i)=scan(d, (i), " "); end;
array vare (6) e1-e6; do i=1 to 6; vare(i)=scan(e, (i), " "); end;
array varf (6) f1-f6; do i=1 to 6; varf(i)=scan(f, (i), " "); end;
run;

proc transpose data=step1 out=multiple  name=position;
var a1-a6 b1-b6 c1-c6 d1-d6 e1-e6 f1-f6;
by certificate;
run; 

data multiple;
set multiple;
if col1 ne "";
chiave=compress (certificate || col1);
line=substr(position, 1, 1);
/*eliminate Z codes which are not included in tables*/
if col1<"Z";
run;
proc sort data=multiple;
by chiave;
run;

/* if on a certificate there is the same code twice in two different lines, the program will keep 
the one on the lower line */
data multiple;
set multiple;
by chiave;
if last.chiave;
drop chiave;
run;

/* here we flag the first record on certificates to count how many certificates we have */
proc sort data=multiple;
by certificate;
run;
data multiple;
set multiple;
by certificate;
if first.certificate then appo=1
;
run;
proc freq data=multiple;
tables appo/noprint out=appo;
where appo=1;
run;
data appo;
set appo;
tot=count;
drop count;
run;

/* calculating frequency of each code in certificates and create a table with frequency and total
number of certificates in each line */
proc freq data=multiple;
tables col1/ noprint out=codelist;
run;
data codelist;
set codelist;
cod1=col1;
freqcod1=count;
drop count percent col1;
run;
/*data codelist_mod;
merge codelist appo  ;
by appo;
drop percent appo;
run;

/* creating two tables with same data to calculate the frequency of codes jointly mentioned
in certificates */
/*data codelist1;
set codelist;
cod1=col1;
codefreq1=COUNT;
keep cod1 codefreq1;
run;
data codelist2;
set codelist;
cod2=col1;
codefreq2=COUNT;
keep cod2 codefreq2;
run;*/

data multiple_1;
set multiple;
certificate1=certificate;
cod1=col1;
line1=line;
keep certificate1 cod1 line1;
data multiple_2;
set multiple;
certificate2=certificate;
cod2=col1;
line2=line;
keep certificate2 cod2 line2;
run;
/*
proc sort data=codelist1;
by cod1;
run;
proc sort data=multiple_1;
by cod1;
run;
data merge_1;
merge codelist1 multiple_1;
by cod1;
run;

proc sort data=codelist2;
by cod2;
run;
proc sort data=multiple_2;
by cod2;
run;
data merge_2;
merge codelist2 multiple_2;
by cod2;
run;
*/
proc sql;
create table crossing as select    certificate1, cod1, certificate2, cod2, line1 , line2 /*, codefreq2, tot*/
from multiple_1, multiple_2 /*, appo*/ 
where certificate1=certificate2 and cod1 ne cod2;
quit;

proc freq data=crossing;
tables cod1*cod2 /noprint out=joint_ment;
run;

data joint_ment;
set joint_ment;
joint_ment=count;
key=compress(cod1||cod2);
drop count percent;
run;

proc sort data=codelist;
by cod1;
run;
proc sort data=joint_ment;
by cod1;
run;
data first_dataset;
merge joint_ment codelist;
by cod1;
keep cod1 freqcod1 cod2 joint_ment key;
run;

/* creating a table to select codes in "dueto" position on certificates */
proc sql;
create table dueto as select    certificate1, cod1, line1, certificate2, cod2,line2
from multiple_1,multiple_2
where (certificate1=certificate2) and (cod1 ne cod2) and (line1<line2);
quit;
proc freq data=dueto;
tables cod1*cod2/noprint out=dueto_obs;
run;
data dueto_obs;
set dueto_obs;
dueto_obs=count;
key=compress(cod1||cod2);
drop count percent;
run;

proc sort data=first_dataset;
by key;
run;
proc sort data=dueto_obs;
by key;
run;

/* merging two tables to obtain a single table with the frequency of jointly mentioned 
codes and, in this certificates, how many times cod1 is in "dueto" position with respect to cod2 */ 
data dataset;
merge dueto_obs first_dataset;
by key;
run;

data dataset;
set dataset;
if dueto_obs = " " then dueto_obs = 0;
run; 


proc sql;
create table final_dataset as select cod1, cod2, freqcod1, joint_ment, dueto_obs , tot
from dataset , appo;
quit; 

/*exporting the .csv file */
proc export
data=final_dataset
dbms=csv
outfile="&path/ScaricoDueTo.csv"
replace;
run;
